# EvPaypal

## Notes

If using transaction items - paypal api requires quantity / unitPrice as well as description.
See EvCheckout for further example.

If tax is also present, set the unitPrice as exVat and pass taxAmount - again see EvCheckout for examples


## takePayment - extras array

### delivery

Delivery element for the extra array should contain the shipping address for the user.
This would be the return of EvAddressBook.Address::getAddress(ID)

### billing

billing element for the extra array should contain the billing address for the user.
This would be the return of EvAddressBook.Address::getAddress(ID)

### user

user element should contain the full user details of the user checking out. Using $Controller->Auth->user() is a good basis.

### description

description is used to override any transaction description message

### totals

totals should contain the extra totals information for a basket. Sub array should contain the following keys, the value would be the amount of that total

* subtotal
* tax
* delivery

### Troubleshooting
When creating a paypal app. If you need to select a sandbox account but there are none to select and there is an existing account:
* Create a new sandbox account, if that doesn't work:
* Make sure you are logged in on the account you are setting up the app for,
* Go to paypal developers and create a business account - https://www.sandbox.paypal.com/uk/webapps/mpp/account-selection 
* In the sandbox accounts for the original paypal account, there is an option to link accounts. Use this and it should find your new account.
* Create the app using the new account.

If you are getting the error INVALID_EXPERIENCE_PROFILE_ID then go to the database of your site. 
In the site settings there should be a row called "Payment Experience Id". 
Set this to blank and it will generate a new id using the current paypal credentials.